package org.apache.commons.lang3.builder;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import org.apache.commons.lang3.ClassUtils;
import org.apache.commons.lang3.builder.RecursiveToStringStyle;
import org.apache.commons.lang3.builder.ReflectionToStringBuilder;

public class MultilineRecursiveToStringStyle extends RecursiveToStringStyle {
  private static final long serialVersionUID = 1L;
  
  private static final int INDENT = 2;
  
  private int spaces = 2;
  
  public MultilineRecursiveToStringStyle() {
    resetIndent();
  }
  
  private void resetIndent() {
    setArrayStart("{" + System.lineSeparator() + spacer(this.spaces));
    setArraySeparator("," + System.lineSeparator() + spacer(this.spaces));
    setArrayEnd(System.lineSeparator() + spacer(this.spaces - 2) + "}");
    setContentStart("[" + System.lineSeparator() + spacer(this.spaces));
    setFieldSeparator("," + System.lineSeparator() + spacer(this.spaces));
    setContentEnd(System.lineSeparator() + spacer(this.spaces - 2) + "]");
  }
  
  private StringBuilder spacer(int spaces) {
    StringBuilder sb = new StringBuilder();
    for (int i = 0; i < spaces; i++)
      sb.append(" "); 
    return sb;
  }
  
  public void appendDetail(StringBuffer buffer, String fieldName, Object value) {
    if (!ClassUtils.isPrimitiveWrapper(value.getClass()) && !String.class.equals(value.getClass()) && 
      accept(value.getClass())) {
      this.spaces += 2;
      resetIndent();
      buffer.append(ReflectionToStringBuilder.toString(value, this));
      this.spaces -= 2;
      resetIndent();
    } else {
      super.appendDetail(buffer, fieldName, value);
    } 
  }
  
  protected void appendDetail(StringBuffer buffer, String fieldName, Object[] array) {
    this.spaces += 2;
    resetIndent();
    super.appendDetail(buffer, fieldName, array);
    this.spaces -= 2;
    resetIndent();
  }
  
  protected void reflectionAppendArrayDetail(StringBuffer buffer, String fieldName, Object array) {
    this.spaces += 2;
    resetIndent();
    super.reflectionAppendArrayDetail(buffer, fieldName, array);
    this.spaces -= 2;
    resetIndent();
  }
  
  protected void appendDetail(StringBuffer buffer, String fieldName, long[] array) {
    this.spaces += 2;
    resetIndent();
    super.appendDetail(buffer, fieldName, array);
    this.spaces -= 2;
    resetIndent();
  }
  
  protected void appendDetail(StringBuffer buffer, String fieldName, int[] array) {
    this.spaces += 2;
    resetIndent();
    super.appendDetail(buffer, fieldName, array);
    this.spaces -= 2;
    resetIndent();
  }
  
  protected void appendDetail(StringBuffer buffer, String fieldName, short[] array) {
    this.spaces += 2;
    resetIndent();
    super.appendDetail(buffer, fieldName, array);
    this.spaces -= 2;
    resetIndent();
  }
  
  protected void appendDetail(StringBuffer buffer, String fieldName, byte[] array) {
    this.spaces += 2;
    resetIndent();
    super.appendDetail(buffer, fieldName, array);
    this.spaces -= 2;
    resetIndent();
  }
  
  protected void appendDetail(StringBuffer buffer, String fieldName, char[] array) {
    this.spaces += 2;
    resetIndent();
    super.appendDetail(buffer, fieldName, array);
    this.spaces -= 2;
    resetIndent();
  }
  
  protected void appendDetail(StringBuffer buffer, String fieldName, double[] array) {
    this.spaces += 2;
    resetIndent();
    super.appendDetail(buffer, fieldName, array);
    this.spaces -= 2;
    resetIndent();
  }
  
  protected void appendDetail(StringBuffer buffer, String fieldName, float[] array) {
    this.spaces += 2;
    resetIndent();
    super.appendDetail(buffer, fieldName, array);
    this.spaces -= 2;
    resetIndent();
  }
  
  protected void appendDetail(StringBuffer buffer, String fieldName, boolean[] array) {
    this.spaces += 2;
    resetIndent();
    super.appendDetail(buffer, fieldName, array);
    this.spaces -= 2;
    resetIndent();
  }
}
